"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.enumToMap = void 0;
function enumToMap(obj, filter, exceptions) {
    const res = {};
    Object.keys(obj).forEach((key) => {
        const value = obj[key];
        if (typeof value !== 'number') {
            return;
        }
        if (filter && !filter.includes(value)) {
            return;
        }
        if (exceptions && exceptions.includes(value)) {
            return;
        }
        res[key] = value;
    });
    return res;
}
exports.enumToMap = enumToMap;
//# sourceMappingURL=utils.js.map